// ---------- Attention: Generated code, please do not modify! -----------  

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.component;

import javax.el.MethodExpression;
import javax.faces.component.ActionSource2;
import javax.faces.context.FacesContext;
import org.apache.myfaces.tobago.context.Markup;
import org.apache.myfaces.tobago.internal.component.AbstractUITabGroup;
import org.apache.myfaces.tobago.model.SwitchType;
import org.apache.myfaces.tobago.renderkit.css.CustomClass;
import org.apache.myfaces.tobago.renderkit.css.Style;
import org.apache.myfaces.tobago.internal.util.ArrayUtils;
import org.apache.myfaces.tobago.internal.util.StringUtils;
import org.apache.myfaces.tobago.internal.util.Deprecation;
import javax.el.ELException;
import javax.faces.FacesException;
import java.util.ArrayList;
import java.util.List;
import javax.el.MethodExpression;
import javax.el.ValueExpression;

/** 
 Renders a tab group which contains tab panels.
  * UIComponent class, generated from template {@code component.stg} with class
  * {@link org.apache.myfaces.tobago.internal.taglib.component.TabGroupTagDeclaration}.
 */
public class UITabGroup
    extends AbstractUITabGroup implements ActionSource2, Visual {

  public static final String COMPONENT_TYPE = "org.apache.myfaces.tobago.TabGroup";

  public static final String COMPONENT_FAMILY = "javax.faces.Panel";


  enum PropertyKeys {
    renderedIndex,
    actionListener,
    switchType,
    tabChangeListener,
    markup,
    immediate,
    action,
    customClass,
    showNavigationBar,
    style,
    tip,
    selectedIndex,
  }

  public String getFamily() {
    return COMPONENT_FAMILY;
  }


  /**
  For internal use. TBD: Check if this is needed any longer.
  <br>Default: <code>0</code>
  */
  public java.lang.Integer getRenderedIndex() {
    Number value  = (Number) getStateHelper().eval(PropertyKeys.renderedIndex);
    if (value != null) {
      return value.intValue();
    }
    return 0;
  }

  public void setRenderedIndex(java.lang.Integer renderedIndex) {
    getStateHelper().put(PropertyKeys.renderedIndex, renderedIndex);
  }

  /**
   * @deprecated since 2.0.0
   */
  @Deprecated
  public javax.faces.el.MethodBinding getActionListener() {
    javax.el.MethodExpression expression = getActionListenerExpression();
    if (expression instanceof MethodBindingToMethodExpression) {
      return ((MethodBindingToMethodExpression)expression).getMethodBinding();
    }
    if (expression != null) {
       return new MethodExpressionToMethodBinding(expression);
    }
    return null;
  }

  /**
   * @deprecated since 2.0.0
   */
  @Deprecated
  public void setActionListener(javax.faces.el.MethodBinding actionListener) {
    if (actionListener != null) {
      setActionListenerExpression(new MethodBindingToMethodExpression(actionListener));
    } else {
      setActionListenerExpression(null);
    }
  }

  public javax.el.MethodExpression getActionListenerExpression() {
    return (javax.el.MethodExpression) getStateHelper().eval(PropertyKeys.actionListener);
  }

  public void setActionListenerExpression(javax.el.MethodExpression actionListener) {
    getStateHelper().put(PropertyKeys.actionListener, actionListener);
  }


  /**
  <p>
   Indicating how tab switching should be done.
   </p>
   <p>
   Possible values are:
   </p>
   <dl>
     <dt>client</dt>
     <dd>Tab switching is done on client, no server Request.</dd>
     <dt>reloadPage</dt>
     <dd>Tab switching is done by server request. Full page is reloaded.</dd>
     <dt>reloadTab</dt>
     <dd>Tab switching is done by server request. Only the Tab is reloaded.</dd>
   </dl>
  <br>Default: <code>client</code><br>Allowed Values: <code>client,reloadPage,reloadTab</code>
  */
  public org.apache.myfaces.tobago.model.SwitchType getSwitchType() {
    org.apache.myfaces.tobago.model.SwitchType switchType = (org.apache.myfaces.tobago.model.SwitchType) getStateHelper().eval(PropertyKeys.switchType);
    if (switchType != null) {
      return switchType;
    }
    return org.apache.myfaces.tobago.model.SwitchType.client;
  }

  public void setSwitchType(org.apache.myfaces.tobago.model.SwitchType switchType) {
    getStateHelper().put(PropertyKeys.switchType, switchType);
  }

  /**
   * @deprecated since 2.0.0
   */
  @Deprecated
  public javax.faces.el.MethodBinding getTabChangeListener() {
    javax.el.MethodExpression expression = getTabChangeListenerExpression();
    if (expression instanceof MethodBindingToMethodExpression) {
      return ((MethodBindingToMethodExpression)expression).getMethodBinding();
    }
    if (expression != null) {
       return new MethodExpressionToMethodBinding(expression);
    }
    return null;
  }

  /**
   * @deprecated since 2.0.0
   */
  @Deprecated
  public void setTabChangeListener(javax.faces.el.MethodBinding tabChangeListener) {
    if (tabChangeListener != null) {
      setTabChangeListenerExpression(new MethodBindingToMethodExpression(tabChangeListener));
    } else {
      setTabChangeListenerExpression(null);
    }
  }

  public javax.el.MethodExpression getTabChangeListenerExpression() {
    return (javax.el.MethodExpression) getStateHelper().eval(PropertyKeys.tabChangeListener);
  }

  public void setTabChangeListenerExpression(javax.el.MethodExpression tabChangeListener) {
    getStateHelper().put(PropertyKeys.tabChangeListener, tabChangeListener);
  }


  public org.apache.myfaces.tobago.context.Markup getMarkup() {
    Object object = getStateHelper().eval(PropertyKeys.markup);
    if (object != null) {
      return Markup.valueOf(object);
    }
    return null;
  }

  public void setMarkup(org.apache.myfaces.tobago.context.Markup markup) {
    getStateHelper().put(PropertyKeys.markup, markup);
  }

  /**
  Flag indicating that, if this component is activated by the user,
   notifications should be delivered to interested listeners and actions
   immediately (that is, during Apply Request Values phase) rather than
   waiting until Invoke Application phase.
  <br>Default: <code>false</code>
  */
  public boolean isImmediate() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.immediate);
    if (bool != null) {
      return bool;
    }
    return false;
  }

  public void setImmediate(boolean immediate) {
    getStateHelper().put(PropertyKeys.immediate, immediate);
  }

  /**
   * @deprecated since 2.0.0
   */
  @Deprecated
  public javax.faces.el.MethodBinding getAction() {
    javax.el.MethodExpression expression = getActionExpression();
    if (expression instanceof MethodBindingToMethodExpression) {
      return ((MethodBindingToMethodExpression)expression).getMethodBinding();
    }
    if (expression != null) {
       return new MethodExpressionToMethodBinding(expression);
    }
    return null;
  }

  /**
   * @deprecated since 2.0.0
   */
  @Deprecated
  public void setAction(javax.faces.el.MethodBinding action) {
    if (action != null) {
      setActionExpression(new MethodBindingToMethodExpression(action));
    } else {
      setActionExpression(null);
    }
  }

  public javax.el.MethodExpression getActionExpression() {
    return (javax.el.MethodExpression) getStateHelper().eval(PropertyKeys.action);
  }

  public void setActionExpression(javax.el.MethodExpression action) {
    getStateHelper().put(PropertyKeys.action, action);
  }


  /**
  Sets a CSS class in its parent, if the parent supports it.

   Which this feature it is possible to put a CSS class name into a component with the &lt;tc:style&gt; tag. Example:

   <pre>
   &lt;tc:in&gt;
     &lt;tc:style customClass="my-emphasized"/&gt;
   &lt;/tc:in&gt;
   </pre>

   One capability is, to used external CSS libs.
   <br>
   This feature should not be used imprudent.
   Because it might be unstable against changes in the renderered HTML code.

  */
  public org.apache.myfaces.tobago.renderkit.css.CustomClass getCustomClass() {
    return (org.apache.myfaces.tobago.renderkit.css.CustomClass) getStateHelper().eval(PropertyKeys.customClass);
  }

  public void setCustomClass(org.apache.myfaces.tobago.renderkit.css.CustomClass customClass) {
    getStateHelper().put(PropertyKeys.customClass, customClass);
  }

  /**
  Flag indicating that the tab navigation bar is rendered.
  <br>Default: <code>true</code>
  */
  public boolean isShowNavigationBar() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.showNavigationBar);
    if (bool != null) {
      return bool;
    }
    return true;
  }

  public void setShowNavigationBar(boolean showNavigationBar) {
    getStateHelper().put(PropertyKeys.showNavigationBar, showNavigationBar);
  }

  /**
  For internal use. Used for rendering, if there is a child tag &lt;tc:style&gt;

  */
  public org.apache.myfaces.tobago.renderkit.css.Style getStyle() {
    return (org.apache.myfaces.tobago.renderkit.css.Style) getStateHelper().eval(PropertyKeys.style);
  }

  public void setStyle(org.apache.myfaces.tobago.renderkit.css.Style style) {
    getStateHelper().put(PropertyKeys.style, style);
  }

  /**
  Text value to display as tooltip.

  */
  public java.lang.String getTip() {
    return (java.lang.String) getStateHelper().eval(PropertyKeys.tip);
  }

  public void setTip(java.lang.String tip) {
    getStateHelper().put(PropertyKeys.tip, tip);
  }

  /**
  <strong>ValueBindingExpression</strong> pointing to a Integer to save the
   component's selected Tab.
  <br>Default: <code>0</code>
  */
  public java.lang.Integer getSelectedIndex() {
    Number value  = (Number) getStateHelper().eval(PropertyKeys.selectedIndex);
    if (value != null) {
      return value.intValue();
    }
    return 0;
  }

  public void setSelectedIndex(java.lang.Integer selectedIndex) {
    getStateHelper().put(PropertyKeys.selectedIndex, selectedIndex);
  }


}